<?php

    class PGDelayedWidgets {                             
        var $widget_form_variable = "pg-delayed-widgets";
        
        
        /**
        * Constructor
        */
        
        function __construct() {
            $this->init();
        }
        
        
        /**
        * Initilize the plugin.
        */
        
        function init() {           
            if (is_admin()) {                                                                                                            
                add_action("admin_print_scripts-widgets.php", array($this, "widgetEditScripts"));
                add_action('admin_print_styles-widgets.php', array($this, 'widgetEditStyles'));  
                add_action("in_widget_form", array($this, "widgetForm"), 99, 3);    
                add_filter("widget_update_callback", array($this, "widgetUpdate"), 99, 4); 
            } else {                                                                                                     
                wp_enqueue_script('pg-delayed-widgets', PG_DW_PLUGIN_URL.'/scripts/script.js', array('jquery'));
                wp_localize_script('pg-delayed-widgets', 'pg_dw_cfg', array('elem_class' => $this->widget_form_variable, 'anim_speed' => '750'));
                add_filter('widget_display_callback', array($this, 'widgetDisplay'), 0, 3);
            }                                 
        } 
        
        
        /**
        * Add scripts on widget edit.
        */
        
        function widgetEditScripts() {
            wp_register_script('pg-dw-jquery-numeric', PG_DW_PLUGIN_URL.'/scripts/jquery.numeric.js', array('jquery'));
            wp_enqueue_script('pg-dw-widget-edit', PG_DW_PLUGIN_URL.'/scripts/widget-edit.js', array('jquery', 'pg-dw-jquery-numeric'));
        }
        
        
        /**
        * Add styles for widget edit.
        */
        
        function widgetEditStyles() {
            wp_enqueue_style('pg-dw-widget-edit', PG_DW_PLUGIN_URL."/styles/widget-edit.css");
        }
        
        
        /**
        * Handler for in_widget_form action.
        * 
        * @param mixed $widget
        * @param mixed $return
        * @param mixed $instance
        */
        
        function widgetForm(&$widget, &$return, $instance) {
            $name = $widget->get_field_name($this->widget_form_variable);
            $value = isset($instance[$this->widget_form_variable]) && is_numeric($instance[$this->widget_form_variable]) ? $instance[$this->widget_form_variable] : 0;
            PGDelayedWidgetsFunctions::loadView('widget-form', array('name' => $name, 'value' => $value));  
        }
        
        /**
        * Handler for wodget_update_callback.
        * 
        * @param mixed $instance
        * @param mixed $new_instance
        * @param mixed $old_instance
        * @param mixed $widget
        */
        
        function widgetUpdate($instance, $new_instance, $old_instance, $widget) {
            $instance[$this->widget_form_variable] = $new_instance[$this->widget_form_variable];
            return $instance;   
        }
        
        /**
        * Handler for widget_display_callback.
        *                                                                
        * @param mixed $instance
        * @param mixed $widget
        * @param mixed $args
        */
        
        function widgetDisplay($instance, $widget, $args) {
            $value = isset($instance[$this->widget_form_variable]) && is_numeric($instance[$this->widget_form_variable]) ? intval($instance[$this->widget_form_variable]) : 0;
            if (0 < $value) {
                PGDelayedWidgetsFunctions::loadView('widget-display', array('pg_dw' => $this, 'widget' => $widget, 'value' => $value));
            }
            return $instance;
        }
    }
  
?>